Skip to main content

REST API Reference

The InstaVM API is organized around REST. All requests use https://api.instavm.io as the base URL.

Authentication​

All API requests require an API key passed in the X-API-Key header:

curl https://api.instavm.io/v1/sessions/session \
-H "X-API-Key: instavm_sk_..."

Get your API key from the InstaVM Dashboard.

Endpoint Categories​

Sessions​

Create and manage execution sessions.

Execution​

Execute code synchronously or asynchronously.

VMs​

Create, list, update, delete, clone, and snapshot VMs.

Snapshots​

Create, list, inspect, and delete snapshots.

Volumes​

Manage persistent volumes, file operations, checkpoints, and VM volume attachments.

File Operations​

Upload and download files.

Browser Automation​

Control headless browsers for web automation.

Computer Use​

Browser-backed computer-use viewer and interaction endpoints.

Egress Policies​

Control outbound network access from sessions and VMs.

SSH Keys​

Manage SSH public keys for VM access.

Shares & Custom Domains​

Expose VM ports and configure custom domains.

API Keys​

Manage API keys for authentication.

Audit Logs​

Read audit events and catalog metadata.

Webhooks​

Manage webhook endpoints and replay/test deliveries.